diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
index a8ca6f9b0..f2ca1c8a2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
@@ -1,8 +1,10 @@
 package net.minecraft.client.render.tessellator;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.IntArrayList;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.BufferUtils;
@@ -15,13 +17,18 @@ public class TessellatorFont {
     private static final Logger LOGGER = LogUtils.getLogger();
     private boolean drawing = false;
 
-    private int color;
+    private int texture = -1;
+    private long config;
+    private boolean shadow;
+
+    private final IntArrayList renderRanges = new IntArrayList(16 * 3);
 
     private final int vao;
     private final int vbo;
 
     private final @NotNull String name;
     private ByteBuffer data;
+    private int start;
     private int vertexCount;
 
     public TessellatorFont(@NotNull String name, int initialCapacity) {
@@ -34,22 +41,20 @@ public class TessellatorFont {
         GL41.glBindVertexArray(this.vao);
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
 
-        int vertSize = 4 * Float.BYTES + 9;
+        int vertSize = 2 * Float.BYTES + 9;
         int offset = 0;
-        GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // Pos XY
-        GL41.glVertexAttribPointer(1, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // Width Height
-        GL41.glVertexAttribPointer(2, 1, GL41.GL_BYTE, false,          vertSize, offset); offset += 1; // Shift
-        GL41.glVertexAttribPointer(3, 4, GL41.GL_UNSIGNED_BYTE, true,   vertSize, offset); offset += 4;               // Color
-        GL41.glVertexAttribPointer(4, 2, GL41.GL_UNSIGNED_BYTE, false,   vertSize, offset); offset += 2; // UV
-        GL41.glVertexAttribPointer(5, 2, GL41.GL_UNSIGNED_BYTE, false,   vertSize, offset); offset += 2; // UV Sizes
-        GL41.glVertexAttrib1f(6, LightIndexHelper.lightIndex2i(15, 15));
+        GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false, vertSize, offset); offset += Float.BYTES * 2; // Pos XY
+        GL41.glVertexAttribPointer(1, 2, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 2; // Width Height
+        GL41.glVertexAttribPointer(2, 4, GL41.GL_UNSIGNED_BYTE, true, vertSize, offset); offset += 4; // Color
+        GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 2; // UV
+        GL41.glVertexAttribPointer(4, 1, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 1; // Config
+        GL41.glVertexAttrib1f(5, LightIndexHelper.lightIndex2i(15, 15));
 
         GL41.glEnableVertexAttribArray(0);
         GL41.glEnableVertexAttribArray(1);
         GL41.glEnableVertexAttribArray(2);
         GL41.glEnableVertexAttribArray(3);
         GL41.glEnableVertexAttribArray(4);
-        GL41.glEnableVertexAttribArray(5);
         GL41.glBindVertexArray(0);
     }
 
@@ -60,31 +65,42 @@ public class TessellatorFont {
         }
 
         this.drawing = true;
+        this.start = 0;
         this.vertexCount = 0;
+        this.texture = -1;
+        this.renderRanges.clear();
         this.data.clear();
 
-        setColor1i(0xFFFFFFFF);
+        this.setConfig(0xFFFFFFFFL);
     }
 
 
-    public void addChar(double x, double y, double width, double height, double shift, double u, double v, double uSize, double vSize) {
+    public void addChar(double x, double y, int width, int height, int u, int v) {
         checkIsDrawing();
         checkCanFit(64);
 
         this.data.putFloat((float) x);
         this.data.putFloat((float) y);
 
-        this.data.putFloat((float) width);
-        this.data.putFloat((float) height);
+        this.data.put((byte) width);
+        this.data.put((byte) height);
 
-        this.data.put((byte) shift);
 
-        this.data.putInt(this.color);
+        long color = (this.config & 0xFFFFFFFFL);
+        byte a = (byte) ((color & 0xFF000000L) >> 24);
+        byte r = (byte) ((color & 0xFF0000L) >> 16);
+        byte g = (byte) ((color & 0xFF00L) >> 8);
+        byte b = (byte) ((color & 0xFFL));
+        if (a == 0) {
+            a = (byte) 0xFF;
+        }
+        this.data.put(r).put(g).put(b).put(a);
 
         this.data.put((byte) u);
         this.data.put((byte) v);
-        this.data.put((byte) uSize);
-        this.data.put((byte) vSize);
+
+        byte packedConfig = (byte) ((this.config >> 32) | (this.shadow ? 0b1000_0000 : 0));
+        this.data.put(packedConfig);
 
         this.vertexCount++;
     }
@@ -95,33 +111,91 @@ public class TessellatorFont {
         }
         this.drawing = false;
 
-        if (this.vertexCount == 0) return;
-
         GL41.glBindVertexArray(this.vao);
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
 
-        GL41.glVertexAttrib1f(6, GLRenderer.getLightIndex());
+        GL41.glVertexAttrib1f(5, GLRenderer.getLightIndex());
         GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
 
-        GL41.glDrawArrays(DrawMode.POINTS.cap, 0, this.vertexCount);
+        for (int i = 0, size = this.renderRanges.size(); i < size; i += 3) {
+            int texture = this.renderRanges.getInt(i);
+            int start = this.renderRanges.getInt(i + 1);
+            int count = this.renderRanges.getInt(i + 2);
+            GL41.glBindTexture(GL41.GL_TEXTURE_2D, texture);
+            GL41.glDrawArrays(DrawMode.POINTS.cap, start, count);
+        }
+
+        if (this.texture != -1) {
+            GL41.glBindTexture(GL41.GL_TEXTURE_2D, this.texture);
+            GL41.glDrawArrays(DrawMode.POINTS.cap, this.start, this.vertexCount);
+        }
+
         GL41.glBindVertexArray(0);
     }
 
-    public void setColor1i(int argb) {
-        checkIsDrawing();
+    public @NotNull FontRenderBuffer record(int vao, int vbo) {
+        if(!this.drawing) {
+            throw new IllegalStateException(this.name + " not drawing!");
+        }
+        this.drawing = false;
+
+        GL41.glBindVertexArray(vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+        int vertSize = 2 * Float.BYTES + 9;
+        int offset = 0;
+        GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false, vertSize, offset); offset += Float.BYTES * 2; // Pos XY
+        GL41.glVertexAttribPointer(1, 2, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 2; // Width Height
+        GL41.glVertexAttribPointer(2, 4, GL41.GL_UNSIGNED_BYTE, true, vertSize, offset); offset += 4; // Color
+        GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 2; // UV
+        GL41.glVertexAttribPointer(4, 1, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 1; // Config
+        GL41.glVertexAttrib1f(5, LightIndexHelper.lightIndex2i(15, 15));
+
+        GL41.glEnableVertexAttribArray(0);
+        GL41.glEnableVertexAttribArray(1);
+        GL41.glEnableVertexAttribArray(2);
+        GL41.glEnableVertexAttribArray(3);
+        GL41.glEnableVertexAttribArray(4);
 
-        int a = (argb >> 24) & 0xFF;
-        int r = (argb >> 16) & 0xFF;
-        int g = (argb >> 8) & 0xFF;
-        int b = argb & 0xFF;
+        GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
+        GL41.glBindVertexArray(0);
+
+        boolean lastValid = this.texture != -1;
+        int[] metadata = new int[this.renderRanges.size() + (lastValid ? 3 : 0)];
+        for (int i = 0, size = this.renderRanges.size(); i < size; i++) {
+            metadata[i] = this.renderRanges.getInt(i);
+        }
+
+        if (lastValid) {
+            metadata[metadata.length - 3] = this.texture;
+            metadata[metadata.length - 2] = this.start;
+            metadata[metadata.length - 1] = this.vertexCount;
+        }
 
-        this.color = a << 24 | b << 16 | g << 8 | r;
+        return new FontRenderBuffer(vao, vbo, metadata);
     }
 
-    public void setColor2i(int rgb, int a) {
-        setColor1i((rgb & 0xFFFFFF) | (a << 24) & 0xFF000000);
+    public void setShadow(boolean shadow) {
+        checkIsDrawing();
+        this.shadow = shadow;
     }
 
+    public void setConfig(long config) {
+        checkIsDrawing();
+        this.config = config;
+    }
+
+    public void setTexture(int texture) {
+        checkIsDrawing();
+        if (this.texture != texture && this.texture != -1) {
+            this.renderRanges.add(this.texture);
+            this.renderRanges.add(this.start);
+            this.renderRanges.add(this.vertexCount);
+            this.start += this.vertexCount;
+            this.vertexCount = 0;
+        }
+        this.texture = texture;
+    }
 
     public void checkIsDrawing() {
         if (!this.drawing) {
@@ -141,4 +215,32 @@ public class TessellatorFont {
             this.data = newBuffer;
         }
     }
+
+    public record FontRenderBuffer(int vao, int vbo, int[] metadata) {
+        public void delete() {
+            GL41.glDeleteVertexArrays(this.vao);
+            GL41.glDeleteBuffers(this.vbo);
+        }
+
+        public void render() {
+            GLRenderer.globalSetUniforms(Shaders.FONT);
+            Shaders.FONT.bind();
+            GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), 0);
+
+            GL41.glBindVertexArray(this.vao);
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+            GL41.glVertexAttrib1f(5, GLRenderer.getLightIndex());
+
+            for (int i = 0, size = this.metadata.length; i < size; i += 3) {
+                int texture = this.metadata[i];
+                int start = this.metadata[i + 1];
+                int count = this.metadata[i + 2];
+                GL41.glBindTexture(GL41.GL_TEXTURE_2D, texture);
+                GL41.glDrawArrays(DrawMode.POINTS.cap, start, count);
+            }
+
+
+            GL41.glBindVertexArray(0);
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
index 2c72be94e..d898f2e42 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
@@ -11,8 +11,8 @@ import org.lwjgl.opengl.GL41;
 import java.nio.ByteBuffer;
 
 public class TessellatorTerrainImpl implements TessellatorGeneral {
-    private final float[] quadPoses = new float[3 * 4];
-    private final float[] quadUVs = new float[2 * 4];
+    private final double[] quadPoses = new double[3 * 4];
+    private final double[] quadUVs = new double[2 * 4];
     private final byte[] quadNormals = new byte[3 * 4];
     private final byte[] quadLightMap = new byte[4];
     private final byte[] quadShade = new byte[4];
@@ -80,9 +80,9 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
         this.checkIsDrawing();
 
         int index = this.quadVertCount % 4;
-        this.quadPoses[index * 3] = (float) (this.offsetX + x);
-        this.quadPoses[index * 3 + 1] = (float) (this.offsetY + y);
-        this.quadPoses[index * 3 + 2] = (float) (this.offsetZ + z);
+        this.quadPoses[index * 3] = this.offsetX + x;
+        this.quadPoses[index * 3 + 1] = this.offsetY + y;
+        this.quadPoses[index * 3 + 2] = this.offsetZ + z;
 
         this.quadColors[index] = this.color;
 
@@ -102,9 +102,9 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
             this.data.resizeIfNeeded(128);
             ByteBuffer buffer = this.data.getBuffer();
 
-            float spX = this.quadPoses[0];
-            float spY = this.quadPoses[1];
-            float spZ = this.quadPoses[2];
+            double spX = this.quadPoses[0];
+            double spY = this.quadPoses[1];
+            double spZ = this.quadPoses[2];
 
             // Average normals for quad
             byte nX = (byte) ((this.quadNormals[0] + this.quadNormals[3] + this.quadNormals[6] + this.quadNormals[9])/4);
@@ -113,22 +113,22 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
 
             int color = this.quadColors[0];
 
-            buffer.putFloat(spX).putFloat(spY).putFloat(spZ);
+            buffer.putFloat((float) spX).putFloat((float) spY).putFloat((float) spZ);
             buffer.put((byte) Color.blueFromInt(color)).put((byte) Color.greenFromInt(color)).put((byte) Color.redFromInt(color));
             buffer.put(nX).put(nY).put(nZ);
 
             buffer.putShort((short) (this.quadUVs[0] * 0xFFFF)).putShort((short) (this.quadUVs[1] * 0xFFFF));
             buffer.put(this.quadShade[0]).put(this.quadLightMap[0]);
 
-            buffer.putShort(MathHelper.toHalfFloat(this.quadPoses[3] - spX)).putShort(MathHelper.toHalfFloat(this.quadPoses[4] - spY)).putShort(MathHelper.toHalfFloat(this.quadPoses[5] - spZ));
+            buffer.putShort(MathHelper.toHalfFloat((float) (this.quadPoses[3] - spX))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[4] - spY))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[5] - spZ)));
             buffer.putShort((short) (this.quadUVs[2] * 0xFFFF)).putShort((short) (this.quadUVs[3] * 0xFFFF));
             buffer.put(this.quadShade[1]).put(this.quadLightMap[1]);
 
-            buffer.putShort(MathHelper.toHalfFloat(this.quadPoses[6] - spX)).putShort(MathHelper.toHalfFloat(this.quadPoses[7] - spY)).putShort(MathHelper.toHalfFloat(this.quadPoses[8] - spZ));
+            buffer.putShort(MathHelper.toHalfFloat((float) (this.quadPoses[6] - spX))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[7] - spY))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[8] - spZ)));
             buffer.putShort((short) (this.quadUVs[4] * 0xFFFF)).putShort((short) (this.quadUVs[5] * 0xFFFF));
             buffer.put(this.quadShade[2]).put(this.quadLightMap[2]);
 
-            buffer.putShort(MathHelper.toHalfFloat(this.quadPoses[9] - spX)).putShort(MathHelper.toHalfFloat(this.quadPoses[10] - spY)).putShort(MathHelper.toHalfFloat(this.quadPoses[11] - spZ));
+            buffer.putShort(MathHelper.toHalfFloat((float) (this.quadPoses[9] - spX))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[10] - spY))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[11] - spZ)));
             buffer.putShort((short) (this.quadUVs[6] * 0xFFFF)).putShort((short) (this.quadUVs[7] * 0xFFFF));
             buffer.put(this.quadShade[3]).put(this.quadLightMap[3]);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
index d1351e425..50f8675f0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
@@ -18,19 +18,17 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
     public void doRender(TessellatorGeneral tessellator, TileEntityFlowerJar tileEntity, double x, double y, double z, float renderPartialTicks) {
         GLRenderer.pushFrame();
         Block<?> block = Blocks.getBlock(tileEntity.flowerInPot);
-        if (block != null) {
-            GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
-            TextureRegistry.worldAtlas.bind();
-            float scaleValue = 0.75F;
-            GLRenderer.modelM4f().scale(scaleValue, scaleValue, scaleValue);
-            GLRenderer.modelM4f().translate(0.66F, 0.75F, 0.66F);
-            GLRenderer.enableState(State.BLEND);
-            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-            Lighting.disable();
-            BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, tileEntity.flowerData, tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
-            Lighting.enableLight();
-            GLRenderer.disableState(State.BLEND);
-        }
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        TextureRegistry.worldAtlas.bind();
+        float scaleValue = 0.75F;
+        GLRenderer.modelM4f().scale(scaleValue, scaleValue, scaleValue);
+        GLRenderer.modelM4f().translate(0.66F, 0.75F, 0.66F);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        Lighting.disable();
+        BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, tileEntity.flowerData, tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
+        Lighting.enableLight();
+        GLRenderer.disableState(State.BLEND);
         GLRenderer.popFrame();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
index f1469c18b..aac3c8ada 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
@@ -40,7 +40,7 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             }
             TilePos tileEntPos = new TilePos(tileEntity.x, tileEntity.y, tileEntity.z);
             TextureRegistry.worldAtlas.bind();
-            GLRenderer.setShader(Shaders.TERRAIN);
+            GLRenderer.setShader(Shaders.ITEM);
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.disableState(State.CULL_FACE);
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index a6787c30d..18ba368f6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -1,15 +1,15 @@
 package net.minecraft.client.render.tileentity;
 
-import it.unimi.dsi.fastutil.ints.IntArrayList;
-import it.unimi.dsi.fastutil.ints.IntList;
-import net.minecraft.client.Minecraft;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.TextOutlineQuality;
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.Font;
+import net.minecraft.client.render.font.FontRendererDefault;
 import net.minecraft.client.render.font.SF;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -24,17 +24,18 @@ import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.Math;
 import org.joml.primitives.AABBd;
+import org.lwjgl.opengl.GL41;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-import java.util.ArrayList;
 import java.util.Iterator;
-import java.util.List;
+import java.util.Map;
 
 public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
 
-    private final Minecraft mc = Minecraft.getMinecraft();
+    private FontRendererDefault fontRenderer = null;
     private final @NotNull StringBuilder builder = new StringBuilder();
     private final String[] signColorTextures = new String[16];
     private final BufferedTextMeshRenderer textMeshRenderer = new BufferedTextMeshRenderer();
@@ -52,6 +53,10 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         if (block == null || !(block.getLogic() instanceof BlockLogicSign sign))
             return; // Check to make sure the block for the entity is present before rendering, some edge cases have the tile entity loaded before the block data and can cause a crash
 
+        if (this.fontRenderer == null) {
+            this.fontRenderer = new FontRendererDefault();
+            this.fontRenderer.init();
+        }
         GLRenderer.pushFrame();
 
         final StaticEntityModel model;
@@ -108,7 +113,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         GLRenderer.popFrame();
 
         // Render text
-        final FontRenderer sr = getFont();
         float lightOffset = 0f;
         if (tileEntity.isGlowing()) {
             lightOffset = 96f;
@@ -152,9 +156,10 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         final int _x = 0;
         final int _y = -tileEntity.signText.length * 5;
         if (tileEntity.isGlowing() && GameSettings.TEXT_OUTLINE_QUALITY.value == TextOutlineQuality.FANCY) {
-            this.textMeshRenderer.render(sr, t, line1, line2, line3, line4, _x, _y, SF.setOutlined(SF.setColor(0, color)));
+            GLRenderer.setLightmapCoord2i(15, 15);
+            this.textMeshRenderer.render(this.fontRenderer, line1, line2, line3, line4, _x, _y, SF.setOutlined(SF.setColor(0, color)));
         } else {
-            this.textMeshRenderer.render(sr, t, line1, line2, line3, line4, _x, _y, SF.setColor(0, color));
+            this.textMeshRenderer.render(this.fontRenderer, line1, line2, line3, line4, _x, _y, SF.setColor(0, color));
         }
         GLRenderer.popFrame();
 
@@ -187,25 +192,22 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
 
     public static class BufferedTextMeshRenderer {
         private static final long MAX_NON_RENDERED_TIME = 120 * 1000;
-        private final @NotNull IntList freeDisplayLists = new IntArrayList();
-        private final @NotNull List<@NotNull MeshEntry> bufferedMeshes = new ArrayList<>();
+        private final @NotNull Map<@NotNull MeshEntry, @NotNull MeshEntry> bufferedMeshes = new Object2ObjectOpenHashMap<>();
 
         private final @NotNull MeshEntry referenceEntry = new MeshEntry("", "", "", "", 0);
 
         public void tick() {
-            final Iterator<MeshEntry> iterator = this.bufferedMeshes.iterator();
+            final Iterator<MeshEntry> iterator = this.bufferedMeshes.values().iterator();
             while (iterator.hasNext()) {
                 final MeshEntry entry = iterator.next();
                 if (System.currentTimeMillis() - entry.lastUse > MAX_NON_RENDERED_TIME) {
-                    assert entry.list != -1;
-                    this.freeDisplayLists.add(entry.list);
                     iterator.remove();
+                    entry.buffer.delete();
                 }
             }
         }
 
-        public void render(@NotNull final FontRenderer sr,
-                           @NotNull final TessellatorGeneral t,
+        public void render(@NotNull final FontRendererDefault sr,
                            @NotNull final CharSequence line1,
                            @NotNull final CharSequence line2,
                            @NotNull final CharSequence line3,
@@ -213,12 +215,11 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
                            final int x, final int y, final long config) {
             GLRenderer.pushFrame();
             GLRenderer.modelM4f().translate(x, y, 0);
-            renderInternal(sr, t, line1, line2, line3, line4, config);
+            renderInternal(sr, line1, line2, line3, line4, config);
             GLRenderer.popFrame();
         }
 
-        private void renderInternal(@NotNull final FontRenderer sr, // TODO Rework text caching!
-                                    @NotNull final TessellatorGeneral t,
+        private void renderInternal(@NotNull final FontRendererDefault sr,
                                     @NotNull final CharSequence line1,
                                     @NotNull final CharSequence line2,
                                     @NotNull final CharSequence line3,
@@ -230,10 +231,29 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
             this.referenceEntry.line4 = line4.toString();
             this.referenceEntry.config = config;
 
-            sr.render(line1, -sr.stringWidth(line1) / 2, 0).setConfig(config).call();
-            sr.render(line2, -sr.stringWidth(line2) / 2, 10).setConfig(config).call();
-            sr.render(line3, -sr.stringWidth(line3) / 2, 20).setConfig(config).call();
-            sr.render(line4, -sr.stringWidth(line4) / 2, 30).setConfig(config).call();
+            TessellatorFont.FontRenderBuffer buffer;
+            if (this.bufferedMeshes.containsKey(this.referenceEntry)) {
+                MeshEntry entry = this.bufferedMeshes.get(this.referenceEntry);
+                entry.lastUse = System.currentTimeMillis();
+                buffer = entry.buffer;
+            } else {
+                Font font = sr.getFont();
+                sr.getTessellator().startDrawing();
+                sr.renderStringRaw(font, line1, -sr.stringWidth(line1) / 2, 0, 0, false, config);
+                sr.renderStringRaw(font, line2, -sr.stringWidth(line2) / 2, 10, 0, false, config);
+                sr.renderStringRaw(font, line3, -sr.stringWidth(line3) / 2, 20, 0, false, config);
+                sr.renderStringRaw(font, line4, -sr.stringWidth(line4) / 2, 30, 0, false, config);
+                buffer = sr.getTessellator().record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
+                MeshEntry entry = new MeshEntry(line1, line2, line3, line4, config);
+                entry.buffer = buffer;
+                entry.lastUse = System.currentTimeMillis();
+                MeshEntry last = this.bufferedMeshes.put(entry, entry);
+                if (last != null) {
+                    last.buffer.delete();
+                }
+            }
+
+            buffer.render();
         }
 
         public static class MeshEntry {
@@ -244,7 +264,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
             public @NotNull String line4;
 
             public long lastUse = 0;
-            public int list = -1;
+            public @Nullable TessellatorFont.FontRenderBuffer buffer = null;
 
             public MeshEntry(final @NotNull CharSequence line1, final @NotNull CharSequence line2, final @NotNull CharSequence line3, final @NotNull CharSequence line4, final long config) {
                 this.config = config;
